
#from tkinter import *
import tkinter as tk
import tksnack



root = tk.Tk()
tksnack.initializeSnack(root)

mysound = tksnack.Sound()
mysound.read('ex1.wav')

params = [
    [ False, 0, -1, 0 ],
    [ True, 0, -1, 1000 ],
    [ False, 0, 5000, 2000 ],
    [ True, 0, 5000, 3000 ],
    [ False, 400, 5000, 4000 ],
    [ True, 400, 5000, 5000 ]
]

gCx = 0
gCxstep = 200
gCy = 800

gCanvheight = gCy
gCanvwidth = gCxstep * len(params)+1


def savePostscript():
    gCanv.postscript( file="test_snack_result.ps", width=gCanvwidth, height=gCanvheight, pagewidth=gCanvwidth, pagex=gCanvwidth/2 )


def makeColormapSegment( prevval, prevr, prevg, prevb, val, r, g, b ):
    cmapseg = []
    num = val - prevval
    kr = (r - prevr) / float(num)
    kg = (g - prevg) / float(num)
    kb = (b - prevb) / float(num)
    for idx in range(1,num+1):
        rx = int(kr * idx + prevr)
        gx = int(kg * idx + prevg)
        bx = int(kb * idx + prevb)
        cmapseg.append( "#%02x%02x%02x" % ( rx,gx,bx) )
    return cmapseg

def makeColormap( colortable ):
#    print( colortable )
    colormap = []
    for val, rgbs in colortable:
        r = rgbs[0]
        g = rgbs[1]
        b = rgbs[2]
        if len(colormap) == 0:
            colormap.append( '#%02x%02x%02x' % (r, g, b) )
        else:
            colormap.extend( makeColormapSegment( prevval, prevr, prevg, prevb, val, r, g, b) )
        prevval = val
        prevr = r
        prevg = g
        prevb = b
    return colormap

colormapValues = [
    [   0, [   0,   0,   0 ] ],
    [  53, [  55,  59,  62 ] ],
    [  81, [  19, 122, 127 ] ],
    [ 165, [ 134, 206, 203 ] ],
    [ 200, [ 195, 229, 231 ] ],
    [ 224, [ 255, 254, 236 ] ],
    [ 255, [ 225,  40, 133 ] ]
]

theColormap = makeColormap( colormapValues )


def createSpectrograms( c, cx, cxstep, cy ):
    fftlen=1024
    winlen=1024

    for param in params:
        c.create_spectrogram( cx, 0,
                              sound=mysound, height=cy, width=cxstep, anchor=tk.NW,
	                      start = int(2500 - param[3] / 2),
	                      end = int(16000 - param[3]),
	                      fftlength=fftlen,
                              winlength=winlen,
	                      logfreqplot=param[0],
	                      bottomfrequency=param[1],
	                      topfrequency=param[2],
	                      gridtspacing=0.20,
	                      gridfspacing=1000,
	                      gridcrosssize=10,
	                      brightest=-20,
                              darkest=-140,
	                      colormap=theColormap
#                              debug=3
                             )
        c.create_rectangle( cx, 0, cx + cxstep, cy, fill="", outline='#00ff00')
        cx += cxstep


gCanv = tksnack.SnackCanvas(root, height=gCanvheight, width=gCanvwidth)
gCanv.pack(side=tk.BOTTOM)
b1 = tk.Button(root, text="Close", command=exit)
b1.pack( side=tk.LEFT, expand=True, fill=tk.BOTH )
b2 = tk.Button(root, text="POSTSCRIPT", command=savePostscript )
b2.pack( side=tk.RIGHT, expand=True, fill=tk.BOTH )

createSpectrograms(gCanv, gCx, gCxstep, gCy )
root.mainloop()


